/*
  RandomMusic.cpp - Allow random music selection.

  Jason Hood, 3 October, 2012.

  Add DATA\UNIVERSE\music.ini to provide additional music entries:

	[music_li_space]
	music_br_space
	music_ku_space
	music_rh_space

	[music_bar_li01]
	music_bar_br01
	music_bar_ku01
	music_bar_rh01

  When Freelancer goes to play the header entry, the plugin will randomly
  choose from the list (including the header).

  Copy RandomMusic.dll to your EXE directory and add it to the [Libraries]
  section of dacom.ini.
*/

#include "common.h"
#include <map>
#include <vector>
#include <cstdlib>

#define NAKED	 __declspec( naked )
#define FASTCALL __fastcall


#define ADDR_MUSIC ((PBYTE)0x428916)


DWORD dummy;
#define ProtectX( addr, size ) \
  VirtualProtect( addr, size, PAGE_EXECUTE_READWRITE, &dummy )

#define RELOFS( from, to ) \
  *(PDWORD)(from) = (DWORD)(to) - (DWORD)(from) - 4

#define CALL( from, to ) \
  *(PBYTE)(from) = 0xE8; \
  RELOFS( (DWORD)from+1, to )

#define CALL1( from, to ) \
  CALL( from, to ); \
  ((PBYTE)(from))[5] = 0x90


typedef std::vector<UINT> VecUint;
typedef std::map<UINT, VecUint> MusicMap;
typedef MusicMap::const_iterator MusicCIter;

MusicMap music;


bool ReadMusic()
{
  bool rc = false;
  INI_Reader ini;

  // Assume "data path = ..\data".
  if (ini.open( "..\\data\\universe\\music.ini" ))
  {
    while (ini.read_header())
    {
      VecUint list;
      UINT mus = CreateID( ini.get_header_ptr() );
      list.push_back( mus );
      while (ini.read_value())
	list.push_back( CreateID( ini.get_name_ptr() ) );
      if (list.size() > 1)
      {
	music[mus] = list;
	rc = true;
      }
    }
  }
  return rc;
}


void FASTCALL SelectMusic( UINT& mus )
{
  MusicCIter iter = music.find( mus );
  if (iter != music.end())
    mus = iter->second[rand() % iter->second.size()];
}


NAKED
void Music_Hook()
{
  __asm {
	push	eax
	mov	esi, [esp+0x2c+8]
	xor	ebx, ebx
	mov	ecx, esi
	call	SelectMusic
	pop	eax
	ret
  }
}


void Patch( void )
{
  ProtectX( ADDR_MUSIC, 6 );
  CALL1( ADDR_MUSIC, Music_Hook );
}


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
  if (fdwReason == DLL_PROCESS_ATTACH && ReadMusic())
    Patch();

  return TRUE;
}
